package net.wanji.web.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import io.jsonwebtoken.lang.Objects;
import io.netty.util.internal.StringUtil;
import net.wanji.databus.dao.entity.*;
import net.wanji.databus.dao.mapper.*;
import net.wanji.databus.po.BaseCrossInfoPO;
import net.wanji.databus.po.CrossBaseLaneInfoPO;
import net.wanji.databus.po.CrossTurnInfoPO;
import net.wanji.web.common.util.StringUtils;
import net.wanji.web.service.BaseInfoService;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.ArrayList;
import java.util.List;

/**
 * @author duanruiming
 * @date 2024/11/13 20:33
 */
@Service
public class BaseInfoServiceImpl implements BaseInfoService {

    @Resource
    private RidInfoMapper ridInfoMapper;
    @Resource
    private BaseCrossInfoMapper baseCrossInfoMapper;
    @Resource
    private CrossBaseLaneInfoMapper crossBaseLaneInfoMapper;
    @Resource
    private BaseCrossTurnInfoMapper baseCrossTurnInfoMapper;
    @Resource
    private GreenwaveInfoMapper greenwaveInfoMapper;
    @Resource
    private GreenwaveCrossMapper greenwaveCrossMapper;
    @Resource
    private GreenwaveRidMapper greenwaveRidMapper;

    @Resource
    private LinkInfoMapper linkInfoMapper;


    @Override
    public List<BaseCrossInfoPO> crossInfoList() {
        List<BaseCrossInfoPO> list = baseCrossInfoMapper.selectAll();
        return list;
    }

    @Override
    public List<CrossBaseLaneInfoPO> laneInfoList() {
        LambdaQueryWrapper<CrossBaseLaneInfoPO> queryWrapper = new LambdaQueryWrapper<>();
        List<CrossBaseLaneInfoPO> crossBaseLaneInfoPOS = crossBaseLaneInfoMapper.selectList(queryWrapper);
        return crossBaseLaneInfoPOS;
    }

    @Override
    public List<RidInfoEntity> ridInfoList() {
        List<RidInfoEntity> ridInfoEntities = ridInfoMapper.selectAll();
        return ridInfoEntities;
    }

    @Override
    public List<CrossTurnInfoPO> turnInfoList() {
        List<CrossTurnInfoPO> crossTurnInfoPOS = baseCrossTurnInfoMapper.selectAll();
        return crossTurnInfoPOS;
    }

    @Override
    public List<GreenwaveInfoPO> greenInfoList() {
        List<GreenwaveInfoPO> greenwaveInfoPOS = greenwaveInfoMapper.selectAll();
        return greenwaveInfoPOS;
    }

    @Override
    public List<GreenwaveCrossPO> greenCrossInfoList() {
        List<GreenwaveCrossPO> greenwaveCrossPOS = greenwaveCrossMapper.selectAll();
        return greenwaveCrossPOS;
    }

    @Override
    public List<GreenwaveRidPO> greenRidInfoList() {
        LambdaQueryWrapper<GreenwaveRidPO> queryWrapper = new LambdaQueryWrapper<>();
        List<GreenwaveRidPO> greenwaveRidPOS = greenwaveRidMapper.selectList(queryWrapper);
        return greenwaveRidPOS;
    }

    @Override
    public List<LinkInfoEntity> linkInfoList(String rid) {
        List<LinkInfoEntity> linkInfoEntities=new ArrayList<>();
        if(StringUtil.isNullOrEmpty(rid)) {
            linkInfoEntities = linkInfoMapper.selectAll();
        }else {
            linkInfoEntities = linkInfoMapper.selectByRid(rid);
        }
        return linkInfoEntities;
    }
}
